package fr.demo;


import javax.ejb.FinderException;
import javax.naming.NamingException;
import javax.naming.InitialContext;
import java.rmi.RemoteException;
import javax.servlet.http.HttpServletRequest;
import org.objectweb.orchestra.demo.college.CollegeSession;
import org.objectweb.orchestra.demo.college.CollegeSessionHome;
import javax.rmi.PortableRemoteObject;
import java.util.Vector;


/**
 * @author Souillard Charles
 */
public class Bd {
    
    private CollegeSessionHome csh = null;
    private CollegeSession cs = null;
    
	public Bd() throws Exception {
	    try {           
            InitialContext initialContext = new InitialContext();
            try {
               Object objRef = initialContext.lookup(CollegeSessionHome.JNDI_NAME);
               csh = (CollegeSessionHome) PortableRemoteObject.narrow(objRef, CollegeSessionHome.class);
            } finally {
               initialContext.close();
            }
            cs = csh.create();
        } catch (NamingException e) {
            throw new Exception("NamingException CollegeDemo Bd constructor :\n", e);
        } catch (RemoteException e) {
            throw new Exception("RemoteException CollegeDemo Bd constructor :\n", e);
        }
	}
	

	public void addUser(String name, String firstName, String number, String street, String cp, String city, String classe, String station) throws Exception {
	    cs.addUser(name, firstName, number, street, cp, city, classe, station);
	}

	public boolean archiveExist(String schoolRecordNb, String name)throws Exception{
	    boolean result = cs.archiveExist(schoolRecordNb,name);
	    return result;
	}

	public boolean archiveFinish(String schoolRecordNb, HttpServletRequest request)throws Exception{
	    Vector res = cs.archiveFinish(schoolRecordNb);
	    boolean finished = ((Boolean)res.get(0)).booleanValue();
	    request.setAttribute("schoolRecordNb",schoolRecordNb);
		request.setAttribute("name",(String)res.get(1));
		request.setAttribute("firstName",(String)res.get(2));
		request.setAttribute("number",(String)res.get(3));
		request.setAttribute("street",(String)res.get(4));
		request.setAttribute("cp",(String)res.get(5));
		request.setAttribute("city",(String)res.get(6));
		request.setAttribute("classe",(String)res.get(7));
		request.setAttribute("station",(String)res.get(8));
	    if (finished) {
	        request.setAttribute("validationAgreement",(String)res.get(9));
			request.setAttribute("subsidyAgreement",(String)res.get(10));
			request.setAttribute("schoolBusArrival",(String)res.get(11));
			request.setAttribute("schoolBusCompanyResponse",(String)res.get(12));
			request.setAttribute("schoolBusCompanyRecordNb",(String)res.get(13));
	    }
	    return finished;
	}

	public long getSchoolRecordNb(String name, String firstName, String street) throws Exception{
	    long resultat = cs.getCollegeRecordNb(name, firstName, street);
		return resultat;
	}

	public void modifyArchive(String schoolRecordNb,String name,String firstName,String validationAgreement,String subsidyAgreement,String schoolBusCompanyResponse,String classNb,String schoolBusDeparture,String schoolBusArrival,String schoolBusCompanyNb)throws Exception{
	    cs.modifyArchive(schoolRecordNb,name,firstName, validationAgreement, subsidyAgreement, schoolBusCompanyResponse, schoolBusArrival, schoolBusCompanyNb);
	}

	public boolean userExist(String name, String firstName, String street)throws Exception{
	    return getSchoolRecordNb(name, firstName,street) != 0;
	}
}
