package org.objectweb.orchestra.samples.jmsqueue;

import javax.jms.MessageProducer;
import javax.jms.MessageConsumer;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;

import java.util.Date;

public class JmsqueueClient {
    static String receive(String queueName) throws Exception {
        Context jndi = new InitialContext();
        QueueConnectionFactory  qcf = (QueueConnectionFactory)jndi.lookup("JQCF");
        Queue queue=(Queue) jndi.lookup(queueName);
        QueueConnection qc = qcf.createQueueConnection();
        Session session = qc.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
        MessageConsumer receiver = session.createConsumer(queue);
        qc.start();
        TextMessage tm = (TextMessage)receiver.receiveNoWait();
        if (tm == null) tm = session.createTextMessage("Timeout: no message returned");
        session.close();
        qc.close();
        return tm.getText();
    }
    public static void main(String[] args) {
        int argNb = 2;
        if (args.length < argNb) {
            System.out.println("Number of arguments needed : " + argNb);
            System.out.println("Args: <queue> <message text>");
        } else {
            try {
                String queueName = args[0];
                System.out.println(">>>>> JMSQUEUE Input :" + queueName);
                JmsqueueServiceBP is = new JmsqueueServiceBPLocator(); // BPEL Service Locator
                JmsqueuePT ipt = is.getJmsqueuePT();
                InitiateJmsqueueType in = new InitiateJmsqueueType();
                in.setQueue(args[0]);
                StringBuffer message = new StringBuffer();
                message.append("");
                for(int i = 1; i < args.length; ++i)
                    message.append(args[i]).append(" ");
                message.append(new Date().toString());
                in.setMessage(message.toString());
                InitiateJmsqueueResponseType out = ipt.initiate(in);
                System.out.print(">>>>> JMSQUEUE Response received: ");
                System.out.println(out.getResult());
                String qMessage = receive(queueName);
                if (message.toString().equals(qMessage)) {
                    System.out.println(">>>>> JMSQUEUE message equal");
                }
                else {
                    System.out.println(">>>>> JMSQUEUE message NOT equal");
                    System.out.println(">>>>> Expecting: " + message.toString());
                    System.out.println(">>>>> Received: " + qMessage);
                }

            } catch (Exception e) {
                e.printStackTrace(System.err);
            }
        }
    }
}
