/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package javax.bpelj;

/**
 * PartnerLink.java
 * This is the API defined for referencing partner links from Java snippet
 * as if they were local variables.
 *
 * @author Jean-Noel Rouvignac
 * @version $Id: PartnerLink.java 5 2006-10-20 14:37:44Z lejeuneg $
 * @see "The section 'Using Partner Links from Snippets' of the BPELJ specification (page 15)"
 */
public interface PartnerLink {
    public Object getMyRole();
    public Object getPartnerRole();
    /**
     * Assigns the partner role of a partner link.
     */
    public void setPartnerRole(Object partner);
}

/* A java 5 compliant interface using Generics
public interface PartnerLink<PartnerType, MyType> {
    MyType getMyRole();
    PartnerType getPartnerRole();
    void setPartnerRole(PartnerType partner);
}
 */
