/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.admin;

import java.io.Serializable;
import java.util.Date;


/**
 * Activity.java.
 * Represents a BPEL activity.
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Activity.java 42 2006-11-27 10:12:20Z souillac $
 *
 */
public class Activity implements Serializable {
    /** the unique nb of this statement among the entire process. */
    private int statementNb;
    /** a string representing the activity type. For example : Switch. */
    private String activityType;
    /** execution date of this activity. */
    private Date activityDate;

    /**
     * Set the statementNb of this activity.
     * @param nb - the statementNb
     */
    public void setStatementNb(final int nb) {
        this.statementNb = nb;
    }

    /**
     * Returns the statementNb of this activity.
     * @return - statementNb
     */
    public int getStatementNb() {
        return this.statementNb;
    }

    /**
     * Set the type of this activity. For example : Switch.
     * @param type - the activity type.
     */
    public void setActivityType(final String type) {
        this.activityType = type;
    }

    /**
     * Returns the activityType of this activity.
     * @return - activityType
     */
    public String getActivityType() {
        return this.activityType;
    }

    /**
     * Set the execution date of this activity.
     * @param d - the date.
     */
    public void setActivityDate(final Date d) {
        this.activityDate = d;
    }

    /**
     * Returns the execution date of this activity.
     * @return - activityDate
     */
    public Date getActivityDate() {
        return this.activityDate;
    }
}
