/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.bindingframework;


/**
 * BFBindingComponent.java
 *
 * @author Eric Hardesty
 * @version $Id: BFBindingComponent.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public interface BFBindingComponent {

    /**
     * Invoke the configured component
     * @param sEnv String wsdl defined Request SOAPEnvelope
     * @param params String params from endpoint specified
     * @return String wsdl defined Response record
     * @throws Exception
     */
    public String invoke(String sEnv, String params) throws Exception;
}