/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.bindingframework.configuration;

import java.util.Properties;

import org.objectweb.orchestra.util.BPELTrace;


/**
 * BindingFramework Sender class
 *
 * @author Eric Hardesty
 * @version $Id: BFSender.java 5 2006-10-20 14:37:44Z lejeuneg $
 */
public class BFSender {
    // class members
    Properties propInfo = null;

    /**
     * constructor.
     */
    public BFSender(Properties prop)  {
        this.propInfo = prop;
    }

    public Properties getProperties() {
        return this.propInfo;
    }

    public String getId() {
        String id = this.propInfo.getProperty("id");
        if (id == null) {
            id = "";
        }
        return id;
    }

    public String getClassStr() {
        String cls = this.propInfo.getProperty("class");
        if (cls == null) {
            cls = "";
        }
        return cls;
    }

    public void printDebug() {
        if (BPELTrace.isBFDebugEnabled())
            BPELTrace.traceBF("  BFSender: " + this + " with " + this.propInfo);
    }
}