/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.objectweb.orchestra.bindingframework.transport.bsoa;

import org.apache.axis.AxisEngine;
import org.apache.axis.MessageContext;
import org.apache.axis.client.Call;
import org.apache.axis.client.Transport;

/**
 * A Transport which will cause an invocation via "bsoa"
 *
 * @author Eric Hardesty
 * @version $Id: BSOATransport.java 5 2006-10-20 14:37:44Z lejeuneg $
 */
public class BSOATransport extends Transport
{
    public BSOATransport() {
        this.transportName = "bsoa";
    }

    /**
     * Set up any transport-specific derived properties in the message context.
     * @param mc the context to set up
     * @param call the Call object
     * @param engine the engine containing the registries
     */
    public void setupMessageContextImpl(MessageContext mc,
            Call call,
            AxisEngine engine) {
        // TODO
    }
}

