/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.bpem.view;

import graph.GraphContainer;
import graph.GraphNode;

/**
 * BPEMGraphitGraphEdge.java
 *
 * @author Bill Murray
 * @version $Id: BPEMGraphitContainer.java 5 2006-10-20 14:37:44Z lejeuneg $
 *          <p>
 *          This class extends the GraphContainer to account for the way we need
 *          to hide edges.
 */
public class BPEMGraphitContainer extends GraphContainer {

    BPEMGraphitContainer(String key) {
        super(key);

        this.layouts.put(BPEMGraphitFlowLayout.class,
                new BPEMGraphitFlowLayout(this));
    }

    /**
     * setExpanded - Tell child nodes if they are under a retracted node or not
     */
    public void setExpanded(boolean b) {
        super.setExpanded(b);

        for (int i = 0; i < this.vChildren.size(); i++) {
            GraphNode child = (GraphNode) this.vChildren.get(i);
            child.setUnderRetracted(!b);
        }
    }

    /**
     * setUnderRetracted - sets the state for this object only. Note that it
     * does not propogate the state to children.
     */
    public void setUnderRetracted(boolean b) {
        //        super.setUnderRetracted(b);
        this.underRetracted = b;
    }
}