/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.data;

import java.io.Serializable;
import java.util.Vector;


/**
 * BPUData.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: BPUData.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class BPUData implements Serializable {
    private int bpuId;
    private String processName;
    private int bpiId;
    private String state;
    private int statementNb;
    private Vector monitor;
    private int currentScopeId;

    public BPUData(int bpuId, String processName, int bpiId, String state, int currentScopeId) {
        this.bpuId = bpuId;
        this.processName = processName;
        this.bpiId = bpiId;
        this.state = state;
        this.monitor = new Vector();
        this.currentScopeId = currentScopeId;
    }

    public BPUData(int bpuId, String processName, int bpiId, String state, int statementNb, Vector monitor, int currentScopeId) {
        this.bpuId = bpuId;
        this.processName = processName;
        this.bpiId = bpiId;
        this.state = state;
        this.statementNb = statementNb;
        this.monitor = monitor;
        this.currentScopeId = currentScopeId;
    }

    public int getBPUId() {
        return this.bpuId;
    }

    public String getProcessName() {
        return this.processName;
    }

    public int getBPIId() {
        return this.bpiId;
    }

    public String getState() {
        return this.state;
    }

    public int getStatementNb() {
        return this.statementNb;
    }

    public void setStatementNb(int statementNb) {
        this.statementNb = statementNb;
    }

    public Vector getMonitor() {
        return this.monitor;
    }

    public int getCurrentScopeId() {
        return this.currentScopeId;
    }

    // WARNING Setters should only be called from Cache Class
    public void setState(String state) {
        this.state = state;
    }

    public void setMonitor(Vector m) {
        this.monitor = m;
    }

    public void setCurrentScopeId(int currentScopeId) {
        this.currentScopeId = currentScopeId;
    }

}
