/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.data;

import java.io.Serializable;
import java.util.Date;


/**
 * BpelProcessData.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: BpelProcessData.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class BpelProcessData implements Serializable {

    private int processId;
    private String processName;
    private String creator;
    private boolean deployed;
    private Date creationDate;

    public BpelProcessData(int pId, String pName, String creator) {
        this.processId = pId;
        this.processName = pName;
        this.creator = creator;
        this.deployed = false;
        this.creationDate = new Date();
    }

    public BpelProcessData(int pId, String pName, String creator, boolean d, Date creationDate) {
        this.processId = pId;
        this.processName = pName;
        this.creator = creator;
        this.deployed = d;
        this.creationDate = creationDate;
    }

    public int getProcessId() {
        return this.processId;
    }

    public String getProcessName() {
        return this.processName;
    }

    public String getCreator() {
        return this.creator;
    }

    public boolean getDeployed() {
        return this.deployed;
    }

    // WARNING Setters should only be called from Cache Class
    public void setDeployed(boolean d) {
        this.deployed = d;
    }

    public Date getCreationDate() {
        return this.creationDate;
    }
}
