/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.data;

import java.io.Serializable;

/**
 * VariableData.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: VariableData.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class VariableData implements Serializable {

    private int variableId;
    private String variableName;
    private String messageType;
    private String varType;
    private String element;
    private String BPELJType;
    private int bpiId;
    private int scopeId;
    private Object value;

    public VariableData(int variableId, String varName, String messageType, String varType, String element, String BPELJType, int bpiId, int scopeId, Object value) {
        this.variableId = variableId;
        this.variableName = varName;
        this.messageType = messageType;
        this.varType = varType;
        this.element = element;
        this.BPELJType = BPELJType;
        this.bpiId = bpiId;
        this.scopeId = scopeId;
        this.value = value;
    }

    public Object getValue() {
        return this.value;
    }

    public String getVariableName() {
        return this.variableName;
    }

    public int getBPIId() {
        return this.bpiId;
    }

    public String getType() {
        return this.varType;
    }

    public String getMessageType() {
        return this.messageType;
    }

    public String getElement() {
        return this.element;
    }

    public String getBPELJType() {
        return this.BPELJType;
    }

    public int getScopeId() {
        return this.scopeId;
    }

    public int getVariableId() {
        return this.variableId;
    }

    // WARNING Setters should only be called from Cache Class
    public void setValue(Object value) {
        this.value = value;
    }

    public void print() {
        System.out.println("VariableData print");
        System.out.println("variableId : " + this.variableId);
        System.out.println("variableName : " + this.variableName);
        System.out.println("messageType : " + this.messageType);
        System.out.println("varType : " + this.varType);
        System.out.println("element : " + this.element);
        System.out.println("BPELJType : " + this.BPELJType);
        System.out.println("bpiId : " + this.bpiId);
        System.out.println("scopeId : " + this.scopeId);
        System.out.println("value : " + this.value);
    }

}