/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.engine;

/**
 * ComplexTypesElement.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: ComplexTypesElement.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class ComplexTypesElement implements java.io.Serializable {

    private String xmlType = null;

    private String javaType = null;

    private String holderType = null;

    /**
     * Default Constructor
     *
     * @param properties
     * @throws Exception
     */
    public ComplexTypesElement(String[] properties) {
        this.xmlType = properties[0];
        this.javaType = properties[1];
        this.holderType = properties[2];
    }

    /**
     * @return
     */
    public String getXmlType() {
        return this.xmlType;
    }

    /**
     * @return
     */
    public String getJavaType() {
        return this.javaType;
    }

    /**
     * @return
     */
    public String getHolderType() {
        return this.holderType;
    }
}