/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.engine;

import org.objectweb.orchestra.util.BPELTrace;

/**
 * PendingCompensationHandler.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: PendingCompensationHandler.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class PendingCompensationHandler {

    private int scopeId;
    private int brancheNb;
    private boolean active;

    /**
     * Default Constructor
     *
     * @param sId
     *            Scope Id
     */
    public PendingCompensationHandler(int sId, int bNb) {
        if (BPELTrace.isEngineDebugEnabled())
            BPELTrace.traceEngine("PendingCompensationHandler Constructor : " + sId);
        this.scopeId = sId;
        this.brancheNb = bNb;
        this.active = false;
        if (BPELTrace.isEngineDebugEnabled())
            BPELTrace.traceEngine("PendingCompensationHandler End Constructor");
    }

    /**
     * @return Scope Id
     */
    public int getScopeId() {
        return this.scopeId;
    }

    public int getBrancheNb() {
        return this.brancheNb;
    }

    public boolean isActive() {
        return this.active;
    }

    public void activate() {
        this.active = true;
    }

    public boolean equals(int sId) {
        return sId == this.scopeId;
    }
}