/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.engine;

/**
 * PendingOnMessage.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: PendingOnMessage.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class PendingOnMessage {

    private int brancheNb;
    private String partnerLink;
    private String portType;
    private String operation;
    private String variable;

    /**
     * Default Constructor
     *
     * @param nb brancheNb
     * @param pl PartnerLink
     * @param pt PortType
     * @param o  Operation
     * @param v  Variable
     */
    public PendingOnMessage(int nb, String pl, String pt, String o, String v) {
        this.brancheNb = nb;
        this.partnerLink = pl;
        this.portType = pt;
        this.operation = o;
        this.variable = v;
    }

    /**
     * @return
     */
    public int getBrancheNb() {
        return this.brancheNb;
    }

    /**
     * @return
     */
    public String getPartnerLink() {
        return this.partnerLink;
    }

    /**
     * @return
     */
    public String getPortType() {
        return this.portType;
    }

    /**
     * @return
     */
    public String getOperation() {
        return this.operation;
    }

    /**
     * @return
     */
    public String getVariable() {
        return this.variable;
    }

}