/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.generator;

import javax.xml.namespace.QName;

import org.objectweb.orchestra.util.BPELString;



/**
 * BindingType.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: BindingType.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class BindingType {

    QName bindingName;
    QName pt;

    /**
     * Constructor
     *
     * @param name
     *            the binding name
     * @param portType
     *            the portType associated to this binding
     */
    public BindingType(QName name, QName portType) {
        this.bindingName = name;
        this.pt = portType;
    }

    /**
     * get the bindingName
     *
     * @return QName the bindingName
     */
    public QName getName() {
        return this.bindingName;
    }

    /**
     * get the portType
     *
     * @return QName the portType
     */
    public QName getType() {
        return this.pt;
    }

    /**
     * check if portType and pt are equals
     *
     * @param portType
     *            the portType searched
     * @return boolean return if portType and pt are equals
     */
    public boolean checkType(String portType) {
        return this.pt.getLocalPart().equals(BPELString.removeNS(portType)) && this.pt.getNamespaceURI().equals(BPELString.getNS(portType));
    }

}