/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.generator;

import javax.xml.namespace.QName;

/**
 * Role.java, represents a partnerLinkType role tag of the wsdl file
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Role.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Role {

    private String name = null;
    private QName portType = null;

    /**
     * Default Constructor
     *
     * @param name
     *            the partnerLinkType role name
     * @param name
     *            the associated portType name
     */
    public Role(String name, QName portType) {
        this.name = name;
        this.portType = portType;
    }

    /**
     * get the role name
     *
     * @return QName the role name
     */
    public String getName() {
        return this.name;
    }

    /**
     * get the associated portType
     *
     * @return QName the portType
     */
    public QName getPortType() {
        return this.portType;
    }

    /**
     * get a string representation of this role
     *
     * @return String a string representation of this role
     */
    public String toString() {
        String st = "Role : \n";
        st += "name = " + this.name + "\n";
        st += "portType = " + this.portType + "\n";
        return st;
    }

}