/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.loadservice;

import org.objectweb.jonas.service.Service;

/**
 * LoadProcessService.java.
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: LoadProcessService.java 46 2006-11-28 09:21:48Z souillac $
 *
 */
public interface LoadProcessService extends Service {

    /**
     * Add a jar to JOnAS ClassLoader to make the process visible by the process
     * engine.
     * @param uriJar - url to the jarFile to add
     * @throws Exception - ex
     */
    void addJar(String uriJar) throws Exception;

    /**
     * Method called when loadService is started by JOnAS server.
     * Init classloaders and deploys WS
     * @throws Exception - ex
     */
    void initProcesses() throws Exception;

    /**
     * Set ejbJarClassLoader to the given classloader.
     * @param ejbJarClassLoader - ejbJarClassLoader
     */
    void setEjbJarClassLoader(final ClassLoader ejbJarClassLoader);
}
