/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.resource.BPELTimerReceiver;

import javax.management.Notification;
import javax.management.NotificationListener;

import org.objectweb.orchestra.exception.BPELUtilException;
import org.objectweb.orchestra.resource.BPELService;
import org.objectweb.orchestra.util.BPELTrace;
import org.objectweb.orchestra.util.JmsUtil;



/**
 * BPELTimerReceiver.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: BPELTimerReceiver.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class BPELTimerReceiver implements BPELTimerReceiverMBean, NotificationListener, BPELService {

    public void handleNotification(Notification n, Object handback) {
        if (BPELTrace.isTimerDebugEnabled()) {
            BPELTrace.traceTimer("TimerReceiver handleNotification");
            BPELTrace.traceTimer("Timer finished Type : " + n.getType() + ", message : " + n.getMessage());
        }
        // send message to BPEL Queue
        String type = n.getType();
        String mess = n.getMessage();
        String[] messParts = mess.split(":");
        int bpiId = Integer.parseInt(messParts[0]);
        //int brancheNb = Integer.parseInt(messParts[1]);
        //int scopeId = Integer.parseInt(messParts[2]);
        //int bpuId = Integer.parseInt(messParts[3]);

        try {
            String[] argsName = null;
            Object argsValue[] = null;
            if (type.indexOf(":") != -1) {
                String[] typeParts = type.split(":");
                type = typeParts[0];
                argsName = new String[]{"Id","brancheNb","scopeId","bpuId"};
                argsValue = new Object[]{new Integer(typeParts[1]),new Integer(messParts[1]),new Integer(messParts[2]),new Integer(messParts[3])};
            } else {
                argsName = new String[]{"brancheNb","scopeId","bpuId"};
                argsValue = new Object[]{new Integer(messParts[1]),new Integer(messParts[2]),new Integer(messParts[3])};
            }
            JmsUtil.sendMessageBPI("timerReceiver",bpiId,type,argsName,argsValue);
        } catch (BPELUtilException e) {
            e.printStackTrace();
        }
        if (BPELTrace.isTimerDebugEnabled())
            BPELTrace.traceTimer("TimerReceiver End handleNotification");
    }

    public void startService() throws Exception {
        //
    }

    public void stopService() {
        //
    }
}