/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tasks;

import java.io.File;

import org.apache.tools.ant.taskdefs.Javac;
import org.apache.tools.ant.types.Path;

/**
 * CompileGeneratedFilesTask.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: CompileGeneratedFilesTask.java 5 2006-10-20 14:37:44Z lejeuneg $
 */
public class CompileGeneratedFilesTask extends StandardDeployTask {

    public CompileGeneratedFilesTask() {
        setTaskName("compileGeneratedFiles");
    }

    public void execute() {
        log("Starting CompileGeneratedFilesTask...");
        createDirs();
        compileFiles();
        log("Finishing CompileGeneratedFilesTask...");
    }

    public void createDirs() {
        createDirName(getProp("build_classes_dir") + this.sep + getProcessName());
    }

    public void compileFiles() {
        Javac j = new Javac();
        j.setProject(getProject());
        Path srcDir = new Path(getProject());
        srcDir.setLocation(new File(getProp("build_tmp_dir") + this.sep + getProcessName()));
        j.setSrcdir(srcDir);
        j.setDestdir(new File(getProp("build_classes_dir") + this.sep + getProcessName()));
        j.setDebug(new Boolean(getProp("opt.javac.debug")).booleanValue());
        j.setOptimize(new Boolean(getProp("opt.javac.optimize")).booleanValue());
        Path compileCP = new Path(getProject());
        compileCP.setPath(getProp("build_tmp_dir") + this.sep + "**" + this.sep + "*.java");
        j.setSourcepath(compileCP);
        j.setTaskName("javac");
        j.setSource(getProp("jdkVersion"));
        j.init();
        j.setClasspath((Path) getProject().getReference("compile.classpath"));
        j.execute();
    }

}