/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Case.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Case.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Case extends Statement {

    private String caseCondition = null;

    public Case(java.lang.Integer nb, String condition) {
        this.statementNb = nb;
        if (isNull(condition)) {
            this.caseCondition = null;
        } else {
            this.caseCondition = condition;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Case";
    }

    public void print() {
        System.out.println("Case : ");
        System.out.println("  caseCondition : " + this.caseCondition);
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println("End Case");
    }

    public String getCondition() {
        return this.caseCondition;
    }
}