/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Catch.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Catch.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Catch extends Statement {

    private String catchFaultName = null;
    private String catchFaultVariable = null;

    public Catch(java.lang.Integer nb, String faultName, String faultVariable) {
        this.statementNb = nb;
        if (isNull(faultName)) {
            this.catchFaultName = null;
        } else {
            this.catchFaultName = faultName;
        }
        if (isNull(faultVariable)) {
            this.catchFaultVariable = null;
        } else {
            this.catchFaultVariable = faultVariable;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Catch";
    }

    public String getFaultName() {
        return this.catchFaultName;
    }

    public String getFaultVariable() {
        return this.catchFaultVariable;
    }

    public void print() {
        System.out.println("Catch : ");
        System.out.println("  catchFaultName : " + this.catchFaultName);
        System.out.println("  catchFaultVariable : " + this.catchFaultVariable);
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println("End Catch");
    }

}