/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Correlation.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Correlation.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Correlation extends Statement {

    private String correlationSet;

    private String initiate;

    private String pattern;

    public Correlation(java.lang.Integer nb, String set, String init, String pat) {
        this.statementNb = nb;
        if (isNull(set)) {
            this.correlationSet = null;
        } else {
            this.correlationSet = set;
        }
        if (isNull(init)) {
            this.initiate = null;
        } else {
            this.initiate = init;
        }
        if (isNull(pat)) {
            this.pattern = null;
        } else {
            this.pattern = init;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Correlation";
    }

    public void print() {
        System.out.println("Correlation : ");
        System.out.println("  CorrelationSet : " + this.correlationSet);
        System.out.println("  Initiate : " + this.initiate);
        System.out.println("  Pattern : " + this.pattern);
        System.out.println("End Correlation");
    }

    public String getCorrelationSet() {
        return this.correlationSet;
    }

    public String getInitiate() {
        return this.initiate;
    }

    public String getPattern() {
        return this.pattern;
    }

}