/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * CorrelationSet.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: CorrelationSet.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class CorrelationSet extends Statement {

    private String CSName = null;

    private String CSProperties = null;

    public CorrelationSet(java.lang.Integer nb, String name, String properties) {
        this.statementNb = nb;
        if (isNull(name)) {
            this.CSName = null;
        } else {
            this.CSName = name;
        }
        if (isNull(properties)) {
            this.CSProperties = null;
        } else {
            this.CSProperties = properties;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "CorrelationSet";
    }

    public void print() {
        System.out.println(" Correlation Set :");
        System.out.println("   CSName : " + this.CSName);
        System.out.println("   CSProperties : " + this.CSProperties);
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println(" End Correlation Set");
    }

    public String getName() {
        return this.CSName;
    }

    public String getProperties() {
        return this.CSProperties;
    }
}