/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * ForEach.java
 *
 * @author Alexandre Greco
 * @version $Id: ForEach.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class ForEach extends Activity {

	private String parallel ;
	private String counterName ;
	private int counter ;
	private String startCounterExpr ;
	private String finalCounterExpr ;
	private int startCounterValue ;
	private int finalCounterValue ;
	private boolean initialised = false ;

    public ForEach(java.lang.Integer nb, String parallel, String counterName, String startCounterExpr, String finalCounterExpr, String name, String joinCondition, String suppressJoinFailure) {
        super(name, joinCondition, suppressJoinFailure);
        this.statementNb = nb;
        this.cmpt = 0;
        this.parallel = parallel ;
        this.counterName = counterName ;
        this.startCounterExpr = startCounterExpr ;
        this.finalCounterExpr = finalCounterExpr ;

    }

    public void print() {
        System.out.println(" ForEach :");
        System.out.println("   ForEachName : " + this.name);
        System.out.println("   parallel : " + this.parallel);
        System.out.println("   counterName : " + this.counterName);
        System.out.println("   startCounterExpr : " + this.startCounterExpr);
        System.out.println("   finalCounterExpr : " + this.finalCounterExpr);
        System.out.println(" End ForEach");
	}

    public boolean isInitialised () {
    		return this.initialised ;
    }

    public void initialise (int startValue, int finalValue) {
		this.startCounterValue = startValue ;
		this.finalCounterValue = finalValue ;
		this.counter = startValue ;
    		this.initialised = true ;
    }

    public void setInitialisedToFalse () {
    		this.initialised = false ;
    }

    public String getParallel () {
    		return this.parallel ;
    }

    public String getStartCounterExpr () {
		return this.startCounterExpr ;
    }

    public String getFinalCounterExpr () {
		return this.finalCounterExpr ;
    }

    public int getStartCounterValue () {
		return this.startCounterValue ;
    }

    public void setStartCounterValue (int startValue) {
    		this.startCounterValue = startValue ;
    }

    public int getFinalCounterValue () {
		return this.finalCounterValue ;
    }

    public void setFinalCounterValue (int finalValue) {
		this.finalCounterValue = finalValue ;
}

    public String getCounterName () {
    		return this.counterName ;
    }

    public void setCounter (int counter) {
    		this.counter = counter ;
    }

    public int getCounter () {
    		return this.counter ;
    }

    public String getType() {
		return "ForEach";
	}

}
