/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * From.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: From.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class From extends Statement {

    private String fromVariable = null;
    private String fromPart = null;
    private String fromPartnerLink = null;
    private String fromEndpointReference = null;
    private String fromProperty = null;
    private String fromExpression = null;
    private String fromOpaque = null;
    private String fromQuery = null;
    private String fromLiteral = null;

    public From(java.lang.Integer nb) {
        this.statementNb = nb;
    }

    public java.lang.Integer getNb() {
        return this.statementNb;
    }

    public String getType() {
        return "From";
    }

    public void print() {
        System.out.println(" From :");
        System.out.println("   fromVariable : " + this.fromVariable);
        System.out.println("   fromPart : " + this.fromPart);
        System.out.println("   fromPartnerLink : " + this.fromPartnerLink);
        System.out.println("   fromEndpointReference : " + this.fromEndpointReference);
        System.out.println("   fromProperty : " + this.fromProperty);
        System.out.println("   fromExpression : " + this.fromExpression);
    }

    public void setVariable(String variable) {
        if (isNull(variable)) {
            this.fromVariable = null;
        } else {
            this.fromVariable = variable;
        }
    }

    public void setPart(String part) {
        if (isNull(part)) {
            this.fromPart = null;
        } else {
            this.fromPart = part;
        }
    }

    public void setPartnerLink(String partnerLink) {
        if (isNull(partnerLink)) {
            this.fromPartnerLink = null;
        } else {
            this.fromPartnerLink = partnerLink;
        }
    }

    public void setEndpointReference(String endpointReference) {
        if (isNull(endpointReference)) {
            this.fromEndpointReference = null;
        } else {
            this.fromEndpointReference = endpointReference;
        }
    }

    public void setProperty(String property) {
        if (isNull(property)) {
            this.fromProperty = null;
        } else {
            this.fromProperty = property;
        }
    }

    public void setExpression(String expression) {
        if (isNull(expression)) {
            this.fromExpression = null;
        } else {
            this.fromExpression = expression;
        }
    }

    public void setOpaque(String opaque) {
        if (isNull(opaque)) {
            this.fromOpaque = null;
        } else {
            this.fromOpaque = opaque;
        }
    }

    public void setQuery(String query) {
        if (isNull(query)) {
            this.fromQuery = null;
        } else {
            this.fromQuery = query;
        }
    }

    public void setLiteral(String literal) {
        if (isNull(literal)) {
            this.fromLiteral = null;
        } else {
            this.fromLiteral = literal;
        }
    }

    public String getVariable() {
        return this.fromVariable;
    }

    public String getPart() {
        return this.fromPart;
    }

    public String getPartnerLink() {
        return this.fromPartnerLink;
    }

    public String getEndpointReference() {
        return this.fromEndpointReference;
    }

    public String getProperty() {
        return this.fromProperty;
    }

    public String getExpression() {
        return this.fromExpression;
    }

    public String getOpaque() {
        return this.fromOpaque;
    }

    public String getQuery() {
        return this.fromQuery;
    }

    public String getLiteral() {
        return this.fromLiteral;
    }
}