/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * PartnerLink.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: PartnerLink.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class PartnerLink extends Statement {

    private String linkName = null;

    private String partnerLinkType = null;

    private String myRole = null;

    private String partnerRole = null;

    public PartnerLink(java.lang.Integer nb, String name, String linkType, String role, String partRole) {
        this.statementNb = nb;
        if (isNull(name)) {
            this.linkName = null;
        } else {
            this.linkName = name;
        }
        if (isNull(linkType)) {
            this.partnerLinkType = null;
        } else {
            this.partnerLinkType = linkType;
        }
        if (isNull(role)) {
            this.myRole = null;
        } else {
            this.myRole = role;
        }
        if (isNull(partRole)) {
            this.partnerRole = null;
        } else {
            this.partnerRole = partRole;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "PartnerLink";
    }

    public void print() {
        System.out.println(" PartnerLink :");
        System.out.println("   linkName : " + this.linkName);
        System.out.println("   partnerLinkType : " + this.partnerLinkType);
        System.out.println("   myRole : " + this.myRole);
        System.out.println("   partnerRole : " + this.partnerRole);
    }

    public String getName() {
        return this.linkName;
    }

    public String getLinkType() {
        return this.partnerLinkType;
    }

    public String getMyRole() {
        return this.myRole;
    }

    public String getPartnerRole() {
        return this.partnerRole;
    }
}