/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Receive.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Receive.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Receive extends Activity {

    private String receivePartnerLink = null;
    private String receivePortType = null;
    private String receiveOperation = null;
    private String receiveVariable = null;
    private String receiveCreateInstance = null;

    public Receive(java.lang.Integer nb, String partnerLink, String portType, String operation, String variable, String createInstance, String name, String joinCondition, String suppressJoinFailure) {
        super(name, joinCondition, suppressJoinFailure);
        this.statementNb = nb;
        if (isNull(partnerLink)) {
            this.receivePartnerLink = null;
        } else {
            this.receivePartnerLink = partnerLink;
        }
        if (isNull(portType)) {
            this.receivePortType = null;
        } else {
            this.receivePortType = portType;
        }
        if (isNull(operation)) {
            this.receiveOperation = null;
        } else {
            this.receiveOperation = operation;
        }
        if (isNull(variable)) {
            this.receiveVariable = null;
        } else {
            this.receiveVariable = variable;
        }
        if (isNull(createInstance)) {
            this.receiveCreateInstance = null;
        } else {
            this.receiveCreateInstance = createInstance;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Receive";
    }

    public void print() {
        System.out.println("Receive");
        System.out.println(" Receive partnerLink : " + this.receivePartnerLink);
        System.out.println(" Receive portType : " + this.receivePortType);
        System.out.println(" Receive operation : " + this.receiveOperation);
        System.out.println(" Receive variable : " + this.receiveVariable);
        System.out.println(" Receive createInstance : " + this.receiveCreateInstance);
        System.out.println(" Receive Name : " + this.name);
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println(" End Receive");
    }

    public String getReceivePartnerLink() {
        return this.receivePartnerLink;
    }

    public String getReceivePortType() {
        return this.receivePortType;
    }

    public String getReceiveOperation() {
        return this.receiveOperation;
    }

    public String getReceiveVariable() {
        return this.receiveVariable;
    }

    public String getReceiveCreateInstance() {
        return this.receiveCreateInstance;
    }

}