/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Reply.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Reply.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Reply extends Activity {

    private String replyPartnerLink = null;

    private String replyPortType = null;

    private String replyOperation = null;

    private String replyVariable = null;

    public Reply(java.lang.Integer nb, String partnerLink, String portType, String operation, String variable, String name, String joinCondition, String suppressJoinFailure) {
        super(name, joinCondition, suppressJoinFailure);
        this.statementNb = nb;
        if (isNull(partnerLink)) {
            this.replyPartnerLink = null;
        } else {
            this.replyPartnerLink = partnerLink;
        }
        if (isNull(portType)) {
            this.replyPortType = null;
        } else {
            this.replyPortType = portType;
        }
        if (isNull(operation)) {
            this.replyOperation = null;
        } else {
            this.replyOperation = operation;
        }
        if (isNull(variable)) {
            this.replyVariable = null;
        } else {
            this.replyVariable = variable;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Reply";
    }

    public void print() {
        System.out.println("Reply");
        System.out.println(" Reply partnerLink : " + this.replyPartnerLink);
        System.out.println(" Reply portType : " + this.replyPortType);
        System.out.println(" Reply operation : " + this.replyOperation);
        System.out.println(" Reply variable : " + this.replyVariable);
        System.out.println(" Reply Name : " + this.name);
        if (this.next != null) {
            this.next.print();
        }
    }

    public String getReplyPartnerLink() {
        return this.replyPartnerLink;
    }

    public String getReplyPortType() {
        return this.replyPortType;
    }

    public String getReplyOperation() {
        return this.replyOperation;
    }

    public String getReplyVariable() {
        return this.replyVariable;
    }

}