/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Source.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Source.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Source extends Statement {

    private String sourceLinkName = null;

    private String sourceTransitionCondition = null;

    public Source(java.lang.Integer nb, String linkName, String transitionCondition) {
        this.statementNb = nb;
        if (isNull(linkName)) {
            this.sourceLinkName = null;
        } else {
            this.sourceLinkName = linkName;
        }
        if (isNull(transitionCondition)) {
            this.sourceTransitionCondition = "true()";
        } else {
            this.sourceTransitionCondition = transitionCondition;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Source";
    }

    public String getLinkName() {
        return this.sourceLinkName;
    }

    public String getTransitionCondition() {
        return this.sourceTransitionCondition;
    }

    public void print() {
        System.out.println(" Source :");
        System.out.println("   sourceLinkName : " + this.sourceLinkName);
        System.out.println("   sourceTransitionCondition : " + this.sourceTransitionCondition);
    }
}