/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * Throw.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: Throw.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class Throw extends Activity {

    private String throwFaultName = null;

    private String throwFaultVariable = null;

    public Throw(java.lang.Integer nb, String faultName, String faultVariable, String name, String joinCondition, String suppressJoinFailure) {
        super(name, joinCondition, suppressJoinFailure);
        this.statementNb = nb;
        if (isNull(faultName)) {
            this.throwFaultName = null;
        } else {
            this.throwFaultName = faultName;
        }
        if (isNull(faultVariable)) {
            this.throwFaultVariable = null;
        } else {
            this.throwFaultVariable = faultVariable;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "Throw";
    }

    public void print() {
        System.out.println("Throw : ");
        System.out.println("  throwFaultName : " + this.throwFaultName);
        System.out.println("  throwFaultVariable : " + this.throwFaultVariable);
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println("End Throw");
    }

    public String getFaultName() {
        return this.throwFaultName;
    }

    public String getFaultVariable() {
        return this.throwFaultVariable;
    }

}