/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.tree;

/**
 * While.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: While.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class While extends Activity {

    private String whileCondition = null;

    public While(java.lang.Integer nb, String condition, String name, String joinCondition, String suppressJoinFailure) {
        super(name, joinCondition, suppressJoinFailure);
        this.statementNb = nb;
        if (isNull(condition)) {
            this.whileCondition = null;
        } else {
            this.whileCondition = condition;
        }
        this.cmpt = 0;
    }

    public String getType() {
        return "While";
    }

    public void print() {
        System.out.println(" While :");
        System.out.println("   whileName : " + this.whileCondition);
        System.out.println("     Begin While :");
        for (int i = 0; i < this.cmpt; i++) {
            System.out.println("    Child " + i + " :");
            this.childs[i].print();
            System.out.println("    End Child " + i);
        }
        System.out.println("     End While ");
    }

    public String getCondition() {
        return this.whileCondition;
    }

}