/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.util;

import java.util.Hashtable;

import org.objectweb.orchestra.exception.BPELGeneratorException;
import org.objectweb.orchestra.exception.BPELUtilException;
import org.objectweb.orchestra.generator.Process;


/**
 * BPELMap.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: BPELMap.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class BPELMap {
    public static Hashtable bpels = new Hashtable();

    public static synchronized Process getProcess(String processName) throws BPELUtilException {
        Process result = (Process) bpels.get(processName);
        if (result == null) {
            result = new Process(processName);
            try {
                result.fillProperties();
            } catch (BPELGeneratorException e) {
                throw new BPELUtilException("BPELGeneratorException caught in BPELMap.getProcess : ",e);
            }
            bpels.put(processName,result);
        }
        return result;
    }

    public static synchronized void removeProcess(String processName) {
        bpels.remove(processName);
    }

}
