/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.objectweb.orchestra.util;

import javax.ejb.FinderException;
import javax.naming.NamingException;

import org.objectweb.orchestra.exception.BPELEngineException;

import org.objectweb.orchestra.data.ScopeBeanUtil;
import org.objectweb.orchestra.data.ScopeHomeLocal;
import org.objectweb.orchestra.data.ScopeLocal;


/**
 * EntityBeansUtil.java
 * 
 * @author Goulven Le Jeune & Charles Souillard
 * @version $Id: EntityBeansUtil.java 5 2006-10-20 14:37:44Z lejeuneg $
 *
 */
public class EntityBeansUtil {

    public static ScopeLocal findScopeBean(int scopeId) throws BPELEngineException {
        ScopeLocal scope = null;
        try {
            ScopeHomeLocal shl = ScopeBeanUtil.getLocalHome();
            scope = shl.findByPrimaryKey(new Integer(scopeId));
        } catch (NamingException e) {
            throw new BPELEngineException("NamingException EntityBeansUtil findScope : \n", e);
        } catch (FinderException e) {
            // Nothing
            //throw new BPELEngineException("FinderException EntityBeansUtil findScope : \n", e);
        }
        return scope;
    }
}
