package org.objectweb.orchestra.tests.load;

import java.lang.Thread;
import java.util.Date;

/**
 * @author souillac
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class LoadAbstractThread extends Thread {

    public int nb = -1;
    public long start = -1;
    public String processName = null;
    public boolean success = false;
    public long execTime = -1;

    public LoadAbstractThread(int nb, String processName) {
        this.nb = nb;
        this.processName = processName;
        this.setName(nb+"_"+processName);
        this.start = new Date().getTime();
    }

    public abstract boolean call() throws Exception;

    public void run() {
        try {
            this.success = call();
        } catch (Exception e) {
            this.success = false;
            System.out.println("Exception caught in LoadAbstractThread.run.");
            e.printStackTrace();
            Util.writeError(e,this.processName,this.nb);
            if (LoadClient.exitOnError()) {
                System.out.println("Exiting...");
                System.exit(0);
            }
        } finally {
            this.execTime = new Date().getTime() - this.start;
            LoadClient.endWait(this);
        }
    }

}
