package org.objectweb.orchestra.tests.load;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class Util {

    public final static String basePack = "org.objectweb.orchestra.tests.load.";
    public final static String logFileExtension = ".log";
    public final static String logFileStart = "Perf_";
    public final static String sep = "-";
    public final static String PARAMETERS = "##PARAMETERS##";
    public final static String DATAS = "##DATAS##";
    public final static String EXECTIME = "##EXECTIME##";
    public final static String STATS = "##STATS";
    public static PrintWriter errorWriter = null;

    public static String getDate() throws Exception {
        return getDate(-1,1);
    }

    public static String getDate(long time, int mode) throws Exception {
        Calendar cal = new GregorianCalendar();
        if (time != -1) {
            cal.setTimeInMillis(time);
        }
        String dateSep = null;
        String timeSep = null;
        String betweenSep = null;
        if (mode == 1) {
            dateSep = "_";
            timeSep = "_";
            betweenSep="_";
        } else if (mode == 2) {
            dateSep = "/";
            timeSep = ":";
            betweenSep=" ";
        }
        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH)+1;
        int day = cal.get(Calendar.DAY_OF_MONTH);
        int hour = cal.get(Calendar.HOUR_OF_DAY);
        int minute = cal.get(Calendar.MINUTE);
        int second = cal.get(Calendar.SECOND);
        String result = "";
        result += year+dateSep;
        result += getString(month)+dateSep;
        result += getString(day)+betweenSep;
        result += getString(hour)+timeSep;
        result += getString(minute)+timeSep;
        result += getString(second);
        return result;
    }

    public static String getString(int i) {
        if (i<10) {
            return "0"+i;
        }
        return Integer.toString(i);
    }

    public static String getTime(long l) {
        //1 hour = 3600000 ms
        long a = 3600000;
        //1 minute = 60000 ms
        long b = 60000;
        //1 second = 1000 ms
        long c = 1000;

        long h = l/a;
        long m = (l-a*h)/b;
        long s = (l-a*h-b*m)/c;
        long ms = l-a*h-b*m-c*s;
        String st = h+"h "+m+"m "+s+"s "+ms+"ms";
        return st;
    }

    public static String getDateTimeFromFile(String s) {
        int y = Integer.parseInt(s.substring(0,4));
        int mo = Integer.parseInt(s.substring(5,7));
        int d = Integer.parseInt(s.substring(8,10));
        int h = Integer.parseInt(s.substring(11,13));
        int m = Integer.parseInt(s.substring(14,16));
        int sec = Integer.parseInt(s.substring(17));
        String st = y+"/"+mo+"/"+d+" "+h+":"+m+":"+sec;
        return st;
    }

    public static void setErrorWriter(FileWriter fw) {
        errorWriter = new PrintWriter(fw);
    }

    public static void writeError(Exception e, String processName, int nb) {
        String date = "notInitialyzed";
        try {
            date = getDate(System.currentTimeMillis(),2);
        } catch (Exception ex) {
            //
        }
        errorWriter.println();
        errorWriter.println("*******************************************");
        errorWriter.println("Process = "+processName);
        errorWriter.println("Nb = "+nb);
        errorWriter.println("Date = "+date);
        errorWriter.println("*******************************************");
        errorWriter.println();
        e.printStackTrace(errorWriter);
    }

}
