package org.objectweb.orchestra.tests.unit.unitBPELJValue;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitBPELJValue.BPELJValuePT;
import org.objectweb.orchestra.tests.unit.unitBPELJValue.BPELJValueServiceBP;
import org.objectweb.orchestra.tests.unit.unitBPELJValue.BPELJValueServiceBPLocator;


public class TestBPELJValue extends TestCase {

    private BPELJValueServiceBP fs = null;
    private BPELJValuePT fpt = null;
    /**
     * This String is used as input for each web service,
     * but since they do not use it internally, it is called
     * unusedInput.
     */
    private String unusedInput = null;

    public TestBPELJValue(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestBPELJValue.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.fs = new BPELJValueServiceBPLocator();
        this.fpt = this.fs.getBPELJValuePT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestBPELJValue(testtorun));
        }
    }

    public void testBPELJValue1() throws Exception {
        String output = this.fpt.BPELJValueMessageType(this.unusedInput);
        assertTrue("BPELJvalue1 error", "true".equals(output));
    }

    public void testBPELJValue2() throws Exception {
        String output = this.fpt.BPELJValueXSDInt(this.unusedInput);
        assertTrue("BPELJvalue2 error", "true".equals(output));
    }

    public void testBPELJValue3() throws Exception {
        String output = this.fpt.BPELJValueXSDIntBlock(this.unusedInput);
        assertTrue("BPELJvalue3 error", "true".equals(output));
    }

    public void testBPELJValue4() throws Exception {
        String output = this.fpt.BPELJValueXSDInteger(this.unusedInput);
        assertTrue("BPELJvalue4 error", "true".equals(output));
    }

    public void testBPELJValue5() throws Exception {
        String output = this.fpt.BPELJValueXSDIntegerBlock(this.unusedInput);
        assertTrue("BPELJvalue5 error", "true".equals(output));
    }

    public void testBPELJValue6() throws Exception {
        String output = this.fpt.BPELJValueXSDHexBinary(this.unusedInput);
        assertTrue("BPELJvalue6 error", "true".equals(output));
    }

    public void testBPELJValue7() throws Exception {
        String output = this.fpt.BPELJValueXSDBase64BinaryBlock(this.unusedInput);
        assertTrue("BPELJvalue7 error", "true".equals(output));
    }

    public void testBPELJValue8() throws Exception {
        String output = this.fpt.BPELJValueType(this.unusedInput);
        assertTrue("BPELJvalue9 error", "true".equals(output));
    }

    public void testBPELJValue9() throws Exception {
        String output = this.fpt.BPELJValueElementBlock(this.unusedInput);
        assertTrue("BPELJvalue10 error", "true".equals(output));
    }

    public void testBPELJValue10() throws Exception {
        String output = this.fpt.BPELJValueJavaBigInteger(this.unusedInput);
        assertTrue("BPELJvalue11 error", "true".equals(output));
    }

    public void testBPELJValue11() throws Exception {
        String output = this.fpt.BPELJValueJavaBigIntegerBlock(this.unusedInput);
        assertTrue("BPELJvalue12 error", "true".equals(output));
    }
}
