package org.objectweb.orchestra.tests.unit.unitCS;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitCS.CSPT;
import org.objectweb.orchestra.tests.unit.unitCS.CSServiceBP;
import org.objectweb.orchestra.tests.unit.unitCS.CSServiceBPLocator;


public class TestCS extends TestCase {

    private boolean tmp;

    private CSServiceBP fs = null;
    private CSPT fpt = null;

    private String cas = new String("1");
    private int integer = 0;
    private String message;

    public TestCS(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestCS.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new CSServiceBPLocator();
        this.fpt = this.fs.getCSPT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestCS(testtorun));
        }
    }

    public void testCS1() throws Exception {

        UnitCSThread p1 = new UnitCSThread(1);
        UnitCSThread p2 = new UnitCSThread(2);

        p1.start();
        p2.start();
        this.message = this.fpt.op1(this.cas, this.integer);
        this.tmp = this.message.equals("CS1");
        assertTrue("cs1 error",this.tmp);
    }

    public void testCS2() throws Exception {

        UnitCSThread p3 = new UnitCSThread(3);
        UnitCSThread p4 = new UnitCSThread(4);

        p3.start();
        p4.start();
        this.message = this.fpt.op2(this.cas, this.integer);
        this.tmp = this.message.equals("CS2");
        assertTrue("cs2 error",this.tmp);
    }

    public void testCS3() throws Exception {

        UnitCSThread p4 = new UnitCSThread(4);

        p4.start();
        this.message = this.fpt.op3(this.cas, this.integer);
        this.tmp = this.message.equals("CS3");
        assertTrue("cs3 error",this.tmp);
    }

}
