package org.objectweb.orchestra.tests.unit.unitFault;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitFault.Fault;
import org.objectweb.orchestra.tests.unit.unitFault.FaultServiceBP;
import org.objectweb.orchestra.tests.unit.unitFault.FaultServiceBPLocator;


public class TestFault extends TestCase {

    private FaultServiceBP sts = null;
    private Fault stpt = null;

    public TestFault(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestFault.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.sts = new FaultServiceBPLocator();
        this.stpt = this.sts.getFault();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestFault(testtorun));
        }
    }

    public void testFault() throws Exception {
        String result = this.stpt.start("test1");
        boolean tmp = result.equals("catch1");
        result = this.stpt.start("test2");
        tmp = tmp && result.equals("catch3");
        result = this.stpt.start("test3");
        tmp = tmp && result.equals("catchAll");
        result = this.stpt.start("test4");
        tmp = tmp && result.equals("catchAll");
        result = this.stpt.start("test5");
        tmp = tmp && result.equals("catch2");
        result = this.stpt.start("test6");
        tmp = tmp && result.equals("catchAll");
        assertTrue("Fault error",tmp);
    }


}



