package org.objectweb.orchestra.tests.unit.unitGenerator;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.URI;
import java.util.Calendar;
import java.util.GregorianCalendar;

import javax.xml.namespace.QName;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.objectweb.orchestra.tests.unit.unitGenerator.GenType;
import org.objectweb.orchestra.tests.unit.unitGenerator.Generator;
import org.objectweb.orchestra.tests.unit.unitGenerator.GeneratorServiceBP;
import org.objectweb.orchestra.tests.unit.unitGenerator.GeneratorServiceBPLocator;
import org.objectweb.orchestra.tests.unit.unitGenerator.InitiateHelloWorldT;
import org.objectweb.orchestra.tests.unit.unitGenerator.InitiateHelloWorldResponseT;
import org.objectweb.orchestra.tests.unit.unitGenerator.holders.InitiateHelloWorldResponseTHolder;
import javax.xml.rpc.holders.StringHolder;
import javax.xml.rpc.holders.IntHolder;

import org.objectweb.orchestra.util.BPELConstants;


public class TestGenerator extends TestCase {

    private GeneratorServiceBP fs = null;
    private Generator fpt = null;

    private static String _0  = "0";
    private static BigInteger _02 = new BigInteger("0");
    private static int _03 = 0;
    private static long _04 = 0;
    private static short _05 = 0;
    private static BigDecimal _06 = new BigDecimal("0");
    private static float _07 = 0;
    private static double _08 = 0.0;
    private static boolean _09 = false;
    private static byte _1 = 0;
    private static long _12 = 0;
    private static int _13 = 0;
    private static short _14 = 0;
    private static QName _15 = new QName("urn:bpel","myQN");
    private static Calendar _16 = new GregorianCalendar();
    private static Calendar _17 = new GregorianCalendar();
    private static Calendar _18 = new GregorianCalendar();
    private static URI _19 = null;
    private static byte[] _110 = new byte[]{0};
    private static byte[] _2 = new byte[]{0};
    private static String _22 = "a";
    private static String _23 = "PT5S";
    private static String _24 = "2004,06";
    private static String _25 = "2005";
    private static String _26 = "06,15";
    private static String _27 = "18";
    private static String _28 = "06";
    private static String _29 = "a";
    private static String _210 = "correct token";
    private static String _3 = "correct language";
    private static String _32 = "correct:name";
    private static String _33 = "correct_ncname";
    private static String _34 = "correct_id";
    private static String _35 = "ab:4";
    private static String _36 = "ab:5";
    private static BigInteger _37 = new BigInteger("0");
    private static BigInteger _38 = new BigInteger("-1");
    private static BigInteger _39 = new BigInteger("0");
    private static BigInteger _310 = new BigInteger("0");
    private static BigInteger _4 = new BigInteger("1");
    private static Integer _42 = null;
    private static Long _43 = null;
    private static Short _44 = null;
    private static Float _45 = null;
    private static Double _46 = null;
    private static Boolean _47 = null;
    private static Byte _48 = null;

    public TestGenerator(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestGenerator.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.fs = new GeneratorServiceBPLocator();
        this.fpt = this.fs.getGenerator();
        try {
            _19 = new URI("http://localhost:9000");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestGenerator(testtorun));
        }
    }

    private static GenType getGentType() {
        GenType gen = new GenType(_0,_02,_03,_04,_05,_06,_07,_08,_09,_1,_12,_13,_14,_15,_16,_17,_18,_19,_110,_2,_22,_23,_24,_25,_26,_27,_28,_29,_210,_3,_32,_33,_34,_35,_36,_37,_38,_39,_310,_4,_42,_43,_44,_45,_46,_47,_48);
        return gen;
    }

    public void testGenerator1() throws Exception {
        boolean tmp = false;
        String res = this.fpt.gen1(getGentType());
        tmp = res.equals("success_gen1");
        assertTrue("testGenerator1", tmp);
    }

    public void testGenerator2() throws Exception {
        boolean tmp = false;
        String res = this.fpt.gen2(_0,_02,_03,_04,_05,_06,_07,_08,_09,_1,_12,_13,_14,_15,_16,_17,_18,_19,_110,_2,_22,_23,_24,_25,_26,_27,_28,_29,_210,_3,_32,_33,_34,_35,_36,_37,_38,_39,_310,_4);
        tmp = res.equals("success_gen2");
        assertTrue("testGenerator2", tmp);
    }

    public void testGenerator3() throws Exception {
        boolean tmp = false;
        InitiateHelloWorldT parameters = new InitiateHelloWorldT("nameElement");
        StringHolder initiate = new StringHolder("initiateElement");
        int myInt = 1;
        InitiateHelloWorldResponseTHolder parameters2 = new InitiateHelloWorldResponseTHolder();
        IntHolder outmyInt = new IntHolder();
        this.fpt.initiate(parameters,initiate,myInt,parameters2,outmyInt);
        tmp = parameters2.value.getResult().equals("Hello "+parameters.getName());
        assertTrue("testGenerator3, parameters", tmp);
        tmp = initiate.value.equals("initiateElement");
        assertTrue("testGenerator3, initiate", tmp);
        tmp = outmyInt.value == myInt;
        assertTrue("testGenerator3, initiate", tmp);
    }

    public void testGenerator4() throws Exception {
        boolean tmp = false;
        String st_parameters1 = "1";
        String st_parameters2 = "2";
        String st_parameters3 = "3";

        IntHolder int_parameters1 = new IntHolder();
        IntHolder int_parameters2 = new IntHolder();
        IntHolder int_parameters4 = new IntHolder();
        this.fpt.initiate2(st_parameters1,st_parameters2,st_parameters3,int_parameters1,int_parameters2,int_parameters4);
        tmp = int_parameters1.value == Integer.parseInt(st_parameters1);
        assertTrue("testGenerator4, parameters1", tmp);
        tmp = int_parameters2.value == Integer.parseInt(st_parameters2);
        assertTrue("testGenerator4, parameters2", tmp);
        tmp = int_parameters4.value == Integer.parseInt(st_parameters3);
        assertTrue("testGenerator4, parameters4", tmp);
    }

}

