package org.objectweb.orchestra.tests.unit.unitInvoke;

import javax.xml.rpc.holders.IntHolder;
import javax.xml.rpc.holders.StringHolder;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.util.InvokeUtil.Adresse;
import org.objectweb.orchestra.tests.util.InvokeUtil.Num;
import org.objectweb.orchestra.tests.util.InvokeUtil.Person;
import org.objectweb.orchestra.tests.util.InvokeUtil.Rue;
import org.objectweb.orchestra.tests.util.InvokeUtil.holders.AdresseHolder;
import org.objectweb.orchestra.tests.util.InvokeUtil.holders.NumHolder;
import org.objectweb.orchestra.tests.util.InvokeUtil.holders.PersonHolder;
import org.objectweb.orchestra.tests.util.InvokeUtil.holders.RueHolder;
import org.objectweb.orchestra.tests.unit.unitInvoke.Invoke;
import org.objectweb.orchestra.tests.unit.unitInvoke.InvokeServiceBP;
import org.objectweb.orchestra.tests.unit.unitInvoke.InvokeServiceBPLocator;


public class TestInvoke extends TestCase {

    private boolean tmp;

    private InvokeServiceBP fs = null;
    private Invoke fpt = null;

    private Adresse in = null;
    private int integer = 0;
    private String st = null;
    private Person person = null;
    private AdresseHolder inh = null;
    private IntHolder integerh = null;
    private StringHolder sth = null;
    private PersonHolder personh = null;

    public TestInvoke(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestInvoke.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.fs=new InvokeServiceBPLocator();
        this.fpt=this.fs.getInvoke();
        this.in = new Adresse();
        this.in.setVille("seyssinet");
        this.in.setCp(38170);
        Rue rue = new Rue();
        rue.setNom("Rousseau");
        Num num = new Num();
        num.setNum1(12);
        num.setNum2(120000);
        rue.setNum(num);
        this.in.setRue(rue);
        this.integer = 2;
        this.st = new String("input string");
        this.person = new Person();
        this.person.setAdresse(this.in);
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestInvoke(testtorun));
        }
    }

    public void testInvoke2() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke2" inputVariable="number"/>
        this.fpt.invoke2(this.in,this.integer,this.st,this.person);
        this.tmp = true;
        assertTrue("Invoke2 error",this.tmp);
    }

    public void testInvoke3() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke3" inputVariable="string"/>
        this.fpt.invoke3(this.in,this.integer,this.st,this.person);
        this.tmp = true;
        assertTrue("Invoke3 error",this.tmp);
    }

    public void testInvoke4() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke4" inputVariable="adr1"/>
        this.fpt.invoke4(this.in,this.integer,this.st,this.person);
        this.tmp = true;
        assertTrue("Invoke4 error",this.tmp);
    }

    public void testInvoke8() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke8" inputVariable="number" outputVariable="string"/>
        String o1 = this.fpt.invoke5(this.in,this.integer,this.st,this.person);
        this.tmp = Integer.parseInt(o1) == (this.integer+1);
        assertTrue("Invoke8 error",this.tmp);
    }

    public void testInvoke9() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke9" inputVariable="string" outputVariable="number"/>
        int o2 = this.fpt.invoke6(this.in,this.integer,this.st,this.person);
        this.tmp = o2 == this.st.length();
        assertTrue("Invoke9 error",this.tmp);
    }

    public void testInvoke10() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke10" inputVariable="adr1" outputVariable="string"/>
        String o3 = this.fpt.invoke7(this.in,this.integer,this.st,this.person);
        this.tmp = o3.equals(this.in.getVille());
        assertTrue("Invoke10 error",this.tmp);
    }

    public void testInvoke11() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke11" inputVariable="number" outputVariable="number"/>
        int o4 = this.fpt.invoke8(this.in,this.integer,this.st,this.person);
        this.tmp = o4 == 4;
        assertTrue("Invoke11 error",this.tmp);
    }

    public void testInvoke12() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke12" inputVariable="string" outputVariable="string"/>
        String o5 = this.fpt.invoke9(this.in,this.integer,this.st,this.person);
        this.tmp = o5.equals("invoke12");
        assertTrue("Invoke12 error",this.tmp);
    }

    public void testInvoke13() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke13" inputVariable="adr1" outputVariable="adr2"/>
        this.inh = new AdresseHolder(this.in);
        this.integerh = new IntHolder(this.integer);
        this.sth = new StringHolder(this.st);
        this.personh = new PersonHolder(this.person);
        this.fpt.invoke10(this.inh,this.integerh,this.sth,this.personh);
        this.tmp = this.inh.value.equals(this.in) && this.integerh.value == (this.integer+1) && this.sth.value.equals("invoke13") && this.personh.value.equals(this.person);
        assertTrue("Invoke13 error",this.tmp);
    }

    public void testInvoke14() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke14" inputVariable="adr1" outputVariable="outcomplex"/>
        NumHolder numh = new NumHolder();
        RueHolder rueh = new RueHolder();
        this.fpt.invoke11(this.in,this.integer,this.st,this.person,numh,rueh);
        this.tmp = numh.value.equals(this.in.getRue().getNum()) && rueh.value.equals(this.in.getRue());
        assertTrue("Invoke14 error",this.tmp);
    }

    public void testInvoke15() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke15" inputVariable="adr1" outputVariable="outcomplex2"/>
        this.inh = new AdresseHolder(this.in);
        this.integerh = new IntHolder(this.integer);
        this.sth = new StringHolder(this.st);
        int o6 = this.fpt.invoke12(this.inh,this.integerh,this.sth,this.person);
        this.tmp = o6 == this.integerh.value && this.inh.value.equals(this.person.getAdresse());
        assertTrue("Invoke15 error",this.tmp);
    }

    public void testInvoke16() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke16" inputVariable="adr1" outputVariable="outcomplex3"/>
        this.inh = new AdresseHolder(this.in);
        this.integerh = new IntHolder(this.integer);
        this.sth = new StringHolder(this.st);
        String o7 = this.fpt.invoke13(this.inh,this.integerh,this.sth,this.person);
        this.tmp = o7.equals(this.sth.value);
        assertTrue("Invoke16 error",this.tmp);
    }

    public void testInvoke17() throws Exception {
        //<invoke partnerLink="util" portType="tns:InvokeUtil" operation="invoke17" inputVariable="adr1" outputVariable="outcomplex4"/>
        this.inh = new AdresseHolder(this.in);
        this.integerh = new IntHolder(this.integer);
        this.sth = new StringHolder(this.st);
        Num o8 = this.fpt.invoke14(this.inh,this.integerh,this.sth,this.person);
        this.tmp = o8.equals(this.inh.value.getRue().getNum());
        assertTrue("Invoke17 error",this.tmp);
    }

}

