package org.objectweb.orchestra.tests.unit.unitSamples;

import javax.xml.rpc.holders.StringHolder;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.objectweb.orchestra.samples.assign.AssignPT;
import org.objectweb.orchestra.samples.assign.AssignServiceBP;
import org.objectweb.orchestra.samples.assign.AssignServiceBPLocator;
import org.objectweb.orchestra.samples.assign.InitiateAssignResponseType;
import org.objectweb.orchestra.samples.assign.InitiateAssignType;
import org.objectweb.orchestra.samples.bpemdemo1.Bpemdemo1PT;
import org.objectweb.orchestra.samples.bpemdemo1.Bpemdemo1ServiceBP;
import org.objectweb.orchestra.samples.bpemdemo1.Bpemdemo1ServiceBPLocator;
import org.objectweb.orchestra.samples.bpemdemo1.Processbpemdemo1ResponseType;
import org.objectweb.orchestra.samples.bpemdemo1.Processbpemdemo1Type;
import org.objectweb.orchestra.samples.echo.EchoPT;
import org.objectweb.orchestra.samples.echo.EchoServiceBP;
import org.objectweb.orchestra.samples.echo.EchoServiceBPLocator;
import org.objectweb.orchestra.samples.echocomplex.EchoComplexPT;
import org.objectweb.orchestra.samples.echocomplex.EchoComplexServiceBP;
import org.objectweb.orchestra.samples.echocomplex.EchoComplexServiceBPLocator;
import org.objectweb.orchestra.samples.helloworld.HelloWorld;
import org.objectweb.orchestra.samples.helloworld.HelloWorldServiceBP;
import org.objectweb.orchestra.samples.helloworld.HelloWorldServiceBPLocator;
import org.objectweb.orchestra.samples.helloworld.InitiateHelloWorldResponseT;
import org.objectweb.orchestra.samples.helloworld.InitiateHelloWorldT;
import org.objectweb.orchestra.samples.incrementService.IncrementServicePT;
import org.objectweb.orchestra.samples.incrementService.IncrementServiceServiceBP;
import org.objectweb.orchestra.samples.incrementService.IncrementServiceServiceBPLocator;
import org.objectweb.orchestra.samples.incrementService.ProcessIncrementServiceResponseType;
import org.objectweb.orchestra.samples.incrementService.ProcessIncrementServiceType;
import org.objectweb.orchestra.samples.invoke.InitiateInvokeResponseType;
import org.objectweb.orchestra.samples.invoke.InitiateInvokeType;
import org.objectweb.orchestra.samples.invoke.InvokePT;
import org.objectweb.orchestra.samples.invoke.InvokeServiceBP;
import org.objectweb.orchestra.samples.invoke.InvokeServiceBPLocator;
import org.objectweb.orchestra.samples.reply.ProcessReplyResponseType;
import org.objectweb.orchestra.samples.reply.ProcessReplyType;
import org.objectweb.orchestra.samples.reply.ReplyPT;
import org.objectweb.orchestra.samples.reply.ReplyServiceBP;
import org.objectweb.orchestra.samples.reply.ReplyServiceBPLocator;
import org.objectweb.orchestra.samples.switchSample.InitiateSwitchResponseType;
import org.objectweb.orchestra.samples.switchSample.InitiateSwitchType;
import org.objectweb.orchestra.samples.switchSample.SwitchPT;
import org.objectweb.orchestra.samples.switchSample.SwitchServiceBP;
import org.objectweb.orchestra.samples.switchSample.SwitchServiceBPLocator;
import org.objectweb.orchestra.samples.wait.InitiateWaitResponseType;
import org.objectweb.orchestra.samples.wait.InitiateWaitType;
import org.objectweb.orchestra.samples.wait.WaitPT;
import org.objectweb.orchestra.samples.wait.WaitServiceBP;
import org.objectweb.orchestra.samples.wait.WaitServiceBPLocator;
import org.objectweb.orchestra.samples.whileSample.InitiateWhileResponseType;
import org.objectweb.orchestra.samples.whileSample.InitiateWhileType;
import org.objectweb.orchestra.samples.whileSample.WhilePT;
import org.objectweb.orchestra.samples.whileSample.WhileServiceBP;
import org.objectweb.orchestra.samples.whileSample.WhileServiceBPLocator;
import org.objectweb.orchestra.samples.factorialService.FactorialServiceServiceBP;
import org.objectweb.orchestra.samples.factorialService.FactorialServiceServiceBPLocator;
import org.objectweb.orchestra.samples.factorialService.FactorialServicePT;
import org.objectweb.orchestra.samples.factorialService.ProcessFactorialServiceType;
import org.objectweb.orchestra.samples.factorialService.ProcessFactorialServiceResponseType;
import org.objectweb.orchestra.samples.list.ListServiceLocator;
import org.objectweb.orchestra.samples.list.ListPT;
import org.objectweb.orchestra.samples.listExternal.GetPartTypeDescriptions;
import org.objectweb.orchestra.samples.listExternal.GetPartTypeDescriptionsResponse;
import org.objectweb.orchestra.samples.listExternal.PartTypeList;
import org.objectweb.orchestra.samples.listExternal.ArrayOf_tns2_PartTypeDescription;
import org.objectweb.orchestra.samples.listExternal.PartTypeDescription;



public class TestSamples extends TestCase {

    private boolean tmp;
    public static String outSeller = null;
    public static String outBuyer = null;

    public TestSamples(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestSamples.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestSamples(testtorun));
        }
    }

    public void testAssign() throws Exception {
        String st = "hello assign";
        AssignServiceBP s = new AssignServiceBPLocator();
        AssignPT pt = s.getAssignPT();
        InitiateAssignType in = new InitiateAssignType();
        in.setName(st);
        InitiateAssignResponseType out = pt.initiate(in);
        this.tmp = out.getResult().equals("Hello "+st);
        assertTrue("testAssign error",this.tmp);
    }

    public void testEcho() throws Exception {
        String st = "echo";
        EchoServiceBP s = new EchoServiceBPLocator();
        EchoPT pt = s.getechoPT();
        StringHolder in = new StringHolder(st);
        pt.echo(in);
        this.tmp = in.value.equals(st);
        assertTrue("testEcho error",this.tmp);
    }

    public void testEchocomplex() throws Exception {
        EchoComplexServiceBP s = new EchoComplexServiceBPLocator();
        EchoComplexPT pt = s.getechoComplexPT();
        org.objectweb.orchestra.samples.echocomplex.Phone in = new org.objectweb.orchestra.samples.echocomplex.Phone();
        int i1 = 10;
        String s1 = "20";
        String s2 = "30";
        in.setAreaCode(i1);
        in.setExchange(s1);
        in.setNumber(s2);
        org.objectweb.orchestra.samples.echocomplex.holders.PhoneHolder ph = new org.objectweb.orchestra.samples.echocomplex.holders.PhoneHolder (in);
        pt.echo(ph);

        this.tmp = ph.value.getAreaCode() == i1;
        this.tmp = this.tmp && ph.value.getExchange().equals(s1);
        this.tmp = this.tmp && ph.value.getNumber().equals(s2);
        assertTrue("testEchocomplex error",this.tmp);
    }

    public void testHelloworld() throws Exception {
        String st = "toto";
        HelloWorldServiceBP s = new HelloWorldServiceBPLocator();
        HelloWorld pt = s.getHelloWorld();
        InitiateHelloWorldT in = new InitiateHelloWorldT();
        in.setName(st);
        InitiateHelloWorldResponseT out = pt.initiate(in);

        this.tmp = out.getResult().equals("Hello "+st);
        assertTrue("testHelloworld error",this.tmp);
    }

    public void testIncrementService() throws Exception {
        int i = 10;
        IncrementServiceServiceBP s = new IncrementServiceServiceBPLocator();
        IncrementServicePT pt = s.getIncrementServicePT();
        ProcessIncrementServiceType in = new ProcessIncrementServiceType();
        in.setValue(i);
        ProcessIncrementServiceResponseType out = pt.process(in);
        this.tmp = out.getResult() == (i + 1);
        assertTrue("testIncrementService error",this.tmp);

    }

    public void testInvoke() throws Exception {
        int i = 11;
        InvokeServiceBP s = new InvokeServiceBPLocator();
        InvokePT pt = s.getInvokePT();
        InitiateInvokeType in = new InitiateInvokeType();
        in.setValue(i);
        InitiateInvokeResponseType out = pt.initiate(in);
        this.tmp = out.getResult() == (i+1);
        assertTrue("testInvoke error",this.tmp);
    }

    public void testMarketplace() throws Exception {
        MarketplaceThread m1 = new MarketplaceThread("buyer");
        MarketplaceThread m2 = new MarketplaceThread("seller");
        m1.start();
        m2.start();
        m1.join(5000);
        m2.join(5000);
        this.tmp = TestSamples.outSeller.equals("Deal Successful");
        this.tmp = this.tmp && TestSamples.outBuyer.equals("Deal Successful");
        assertTrue("testMarketplace error",this.tmp);
    }

    public void testReply() throws Exception {
        String st = "replyString";
        ReplyServiceBP s = new ReplyServiceBPLocator();
        ReplyPT pt = s.getReplyPT();
        ProcessReplyType in = new ProcessReplyType();
        in.setValue(st);
        ProcessReplyResponseType out = pt.process(in);
        this.tmp = out.getResult().equals(st);
        assertTrue("testReply error",this.tmp);
    }


    public void testSwitch() throws Exception {
        SwitchServiceBP s = new SwitchServiceBPLocator();
        SwitchPT pt = s.getSwitchPT();
        InitiateSwitchType in = new InitiateSwitchType();

        int i = -1;
        in.setValue(i);
        InitiateSwitchResponseType out = pt.initiate(in);
        this.tmp = out.getResult().equals("Value is lower or equal than zero");
        assertTrue("testSwitch lower error",this.tmp);

        i = 1;
        in.setValue(i);
        out = pt.initiate(in);
        this.tmp = out.getResult().equals("Value is greater than zero");
        assertTrue("testSwitch greater error",this.tmp);
    }

    public void testWait() throws Exception {
        String st = "PT5S";
        WaitServiceBP s = new WaitServiceBPLocator();
        WaitPT pt = s.getWaitPT();
        InitiateWaitType in = new InitiateWaitType();
        in.setValue(st);
        InitiateWaitResponseType out = pt.initiate(in);
        this.tmp = out.getResult().equals(st);
        assertTrue("testWait error",this.tmp);
    }

    public void testWhile() throws Exception {
        int i = 5;
        WhileServiceBP s = new WhileServiceBPLocator();
        WhilePT pt = s.getWhilePT();
        InitiateWhileType in = new InitiateWhileType();
        in.setValue(i);
        InitiateWhileResponseType out = pt.initiate(in);
        this.tmp = out.getResult() == i;
        assertTrue("testWhile error",this.tmp);
    }

    public void testBpemdemo1() throws Exception {
        int i = 3;
        Bpemdemo1ServiceBP s = new Bpemdemo1ServiceBPLocator();
        Bpemdemo1PT pt = s.getbpemdemo1PT();
        Processbpemdemo1Type in = new Processbpemdemo1Type();
        in.setValue(i);
        Processbpemdemo1ResponseType out = pt.process(in);
        this.tmp = out.getResult() == i;
        assertTrue("testBpemdemo1 error",this.tmp);
    }

    public void testFactorialService() throws Exception {
        double d = 15;
        FactorialServiceServiceBP is = new FactorialServiceServiceBPLocator();
        FactorialServicePT ipt = is.getFactorialServicePT();
        ProcessFactorialServiceType in = new ProcessFactorialServiceType();
        in.setValue(d);
        ProcessFactorialServiceResponseType out = ipt.process(in);
        this.tmp = out.getResult() == 1307674368000.0;
        assertTrue("testFactorialService error",this.tmp);
    }

    public void testList() throws Exception {
        int myint = 12;
        ListServiceLocator fs=new ListServiceLocator();
        ListPT fpt=fs.getListPort();
        GetPartTypeDescriptions in = new GetPartTypeDescriptions();
        in.setPartType(myint);
        GetPartTypeDescriptionsResponse out = fpt.getPartTypeDescriptions(in);
        PartTypeList getPartTypeDescriptionsReturn = out.getGetPartTypeDescriptionsReturn();
        ArrayOf_tns2_PartTypeDescription partList = getPartTypeDescriptionsReturn.getPartList();
        PartTypeDescription[] items = partList.getItem();
        PartTypeDescription item = items[0];
        this.tmp = getPartTypeDescriptionsReturn.getCount() == 1;
        this.tmp = this.tmp && getPartTypeDescriptionsReturn.getPartType() == myint;
        this.tmp = this.tmp && items.length == 1;
        this.tmp = this.tmp && item.getDescription().equals("mydescription");
        this.tmp = this.tmp && item.getPartNumber() == 1;
        this.tmp = this.tmp && item.getSellingPrice() == 1000;
        this.tmp = this.tmp && item.getSize() == 20;
        assertTrue("testList error",this.tmp);
    }

}



