package org.objectweb.orchestra.tests.unit.unitScope;

import javax.xml.rpc.holders.StringHolder;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitScope.Scope;
import org.objectweb.orchestra.tests.unit.unitScope.ScopeServiceBP;
import org.objectweb.orchestra.tests.unit.unitScope.ScopeServiceBPLocator;




public class TestScope extends TestCase {

    private boolean tmp;

    private ScopeServiceBP fs = null;
    private Scope fpt = null;



    public TestScope(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestScope.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.fs = new ScopeServiceBPLocator();
        this.fpt = this.fs.getScope();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestScope(testtorun));
        }
    }

    public void testScope() throws Exception {
        String st = new String("startScope");
        StringHolder var1 = new StringHolder();
        StringHolder var2 = new StringHolder();
        StringHolder var3 = new StringHolder();
        StringHolder var4 = new StringHolder();
        StringHolder while1 = new StringHolder();
        StringHolder while2 = new StringHolder();
        StringHolder while3 = new StringHolder();
        StringHolder while4 = new StringHolder();
        StringHolder while5 = new StringHolder();
        StringHolder flow1 = new StringHolder();
        this.fpt.start(st,var1,var2,var3,var4,while1,while2,while3,while4,while5,flow1);
        this.tmp = var1.value.equals("scopeInit");
        this.tmp = this.tmp && var2.value.equals("scope1");
        this.tmp = this.tmp && var3.value.equals("scope2");
        this.tmp = this.tmp && var4.value == null;
        this.tmp = this.tmp && while1.value.equals("scopeWhile11");
        this.tmp = this.tmp && while2.value.equals("scopeWhile2");
        this.tmp = this.tmp && while3.value.equals("scopeWhile33");
        this.tmp = this.tmp && while4.value.equals("scopeWhile4");
        this.tmp = this.tmp && while5.value.equals("scopeWhile5");
        this.tmp = this.tmp && flow1.value.equals("flow2flow1scopeFlow");
        assertTrue("Scope error",this.tmp);
    }


}



