package org.objectweb.orchestra.tests.unit.unitWhile;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitWhile.UnitWhilePT;
import org.objectweb.orchestra.tests.unit.unitWhile.WhileServiceBP;
import org.objectweb.orchestra.tests.unit.unitWhile.WhileServiceBPLocator;


public class TestWhile extends TestCase {

    private boolean tmp;

    private WhileServiceBP fs = null;
    private UnitWhilePT fpt = null;

    private String cas = null;
    private int integer;
    private String message = null;

    public TestWhile(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestWhile.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new WhileServiceBPLocator();
        this.fpt = this.fs.getunitWhilePT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestWhile(testtorun));
        }
    }

    public void testWhile1() throws Exception {
        this.cas = "1";
        this.integer = 1;
        this.message = this.fpt.while1(this.cas,this.integer);
        this.tmp = this.message.equals("while10");
        assertTrue("while1 error",this.tmp);
    }

    public void testWhile2() throws Exception {
        this.cas = "2";
        this.integer = 0;
        this.message = this.fpt.while1(this.cas,this.integer);
        this.tmp = this.message.equals("while00121012201230124012");
        assertTrue("while2 error",this.tmp);
    }

    public void testWhile3() throws Exception {
        this.cas = "3";
        this.integer = 0;
        this.message = this.fpt.while1(this.cas,this.integer);
        this.tmp = this.message.equals("hello");
        assertTrue("while3 error",this.tmp);
    }

    public void testWhile4() throws Exception {
        this.integer = 200;
        this.message = this.fpt.while2(this.integer);
        String mySt = "seqB";
        for (int i=this.integer;i>0;i--) {
            mySt += Integer.toString(i);
        }
        mySt += "seqC";
        this.tmp = this.message.equals(mySt);
        assertTrue("while4 error",this.tmp);
    }

}



