package org.objectweb.orchestra.tests.unit.unitXPath;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.xml.rpc.holders.BooleanHolder;
import javax.xml.rpc.holders.DoubleHolder;
import javax.xml.rpc.holders.IntHolder;
import javax.xml.rpc.holders.StringHolder;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitXPath.Address;
import org.objectweb.orchestra.tests.unit.unitXPath.CSType;
import org.objectweb.orchestra.tests.unit.unitXPath.CSType2;
import org.objectweb.orchestra.tests.unit.unitXPath.Info;
import org.objectweb.orchestra.tests.unit.unitXPath.Info2;
import org.objectweb.orchestra.tests.unit.unitXPath.Info3;
import org.objectweb.orchestra.tests.unit.unitXPath.Info4;
import org.objectweb.orchestra.tests.unit.unitXPath.Person;
import org.objectweb.orchestra.tests.unit.unitXPath.XPathPT;
import org.objectweb.orchestra.tests.unit.unitXPath.XPathServiceBP;
import org.objectweb.orchestra.tests.unit.unitXPath.XPathServiceBPLocator;



public class TestXPath extends TestCase {



    private boolean tmp;

    private XPathServiceBP fs = null;
    private XPathPT fpt = null;

    public TestXPath(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestXPath.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.fs = new XPathServiceBPLocator();
        this.fpt = this.fs.getXPathPort();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestXPath(testtorun));
        }
    }

    public void testXPath1() throws Exception {
        BooleanHolder bool1 = new BooleanHolder();
        BooleanHolder bool2 = new BooleanHolder();
        BooleanHolder bool3 = new BooleanHolder();
        BooleanHolder bool4 = new BooleanHolder();
        BooleanHolder bool5 = new BooleanHolder();
        BooleanHolder bool6 = new BooleanHolder();
        BooleanHolder bool7 = new BooleanHolder();
        BooleanHolder bool8 = new BooleanHolder();
        BooleanHolder bool9 = new BooleanHolder();
        BooleanHolder bool10 = new BooleanHolder();
        BooleanHolder bool11 = new BooleanHolder();
        this.fpt.op1("",bool1,bool2,bool3,bool4,bool5,bool6,bool7,bool8,bool9,bool10,bool11);
        this.tmp = bool1.value == false;
        assertTrue("op1 error : bool1",this.tmp);
        this.tmp = bool2.value == true;
        assertTrue("op1 error : bool2",this.tmp);
        this.tmp = bool3.value == false;
        assertTrue("op1 error : bool3",this.tmp);
        this.tmp = bool4.value == true;
        assertTrue("op1 error : bool4",this.tmp);
        this.tmp = bool5.value == false;
        assertTrue("op1 error : bool5",this.tmp);
        this.tmp = bool6.value == true;
        assertTrue("op1 error : bool6",this.tmp);
        this.tmp = bool7.value == true;
        assertTrue("op1 error : bool7",this.tmp);
        this.tmp = bool8.value == false;
        assertTrue("op1 error : bool8",this.tmp);
        this.tmp = bool9.value == true;
        assertTrue("op1 error : bool9",this.tmp);
        this.tmp = bool10.value == true;
        assertTrue("op1 error : bool10",this.tmp);
        this.tmp = bool11.value == true;
        assertTrue("op1 error : bool11",this.tmp);
    }

    public void testXPath2() throws Exception {
        IntHolder i1 = new IntHolder();
        IntHolder i2 = new IntHolder();
        IntHolder i3 = new IntHolder();
        IntHolder i4 = new IntHolder();
        IntHolder i5 = new IntHolder();
        IntHolder i6 = new IntHolder();
        IntHolder i7 = new IntHolder();
        IntHolder i8 = new IntHolder();
        IntHolder i9 = new IntHolder();
        IntHolder i10 = new IntHolder();
        this.fpt.op2("",i1,i2,i3,i4,i5,i6,i7,i8,i9,i10);
        this.tmp = i1.value == 5;
        assertTrue("op2 error : i1 = "+i1.value+", insteadOf 5",this.tmp);
        this.tmp = i2.value == 1;
        assertTrue("op2 error : i2 = "+i2.value+", insteadOf 1",this.tmp);
        this.tmp = i3.value == 1;
        assertTrue("op2 error : i3 = "+i3.value+", insteadOf 1",this.tmp);
        this.tmp = i4.value == -1;
        assertTrue("op2 error : i4 = "+i4.value+", insteadOf -1",this.tmp);
        this.tmp = i5.value == -1;
        assertTrue("op2 error : i5 = "+i5.value+", insteadOf -1",this.tmp);
        this.tmp = i6.value == 100;
        assertTrue("op2 error : i6 = "+i6.value+", insteadOf 100",this.tmp);
        this.tmp = i7.value == 4;
        assertTrue("op2 error : i7 = "+i7.value+", insteadOf 4",this.tmp);
        this.tmp = i8.value == 3;
        assertTrue("op2 error : i8 = "+i8.value+", insteadOf 3",this.tmp);
        this.tmp = i9.value == 3;
        assertTrue("op2 error : i9 = "+i9.value+", insteadOf 3",this.tmp);
        this.tmp = i10.value == 4;
        assertTrue("op2 error : i10 = "+i10.value+", insteadOf 4",this.tmp);
    }

    public void testXPath3() throws Exception {
        StringHolder st1 = new StringHolder();
        StringHolder st2 = new StringHolder();
        StringHolder st3 = new StringHolder();
        BooleanHolder st4 = new BooleanHolder();
        BooleanHolder st5 = new BooleanHolder();
        BooleanHolder st6 = new BooleanHolder();
        BooleanHolder st7 = new BooleanHolder();
        StringHolder st8 = new StringHolder();
        StringHolder st9 = new StringHolder();
        StringHolder st10 = new StringHolder();
        StringHolder st11 = new StringHolder();
        DoubleHolder st12 = new DoubleHolder();
        StringHolder st13 = new StringHolder();
        StringHolder st14 = new StringHolder();
        this.fpt.op3("",st1,st2,st3,st4,st5,st6,st7,st8,st9,st10,st11,st12,st13,st14);
        this.tmp = st1.value.equals("314");
        assertTrue("op3 error : st1 = "+st1.value+", insteadOf 314",this.tmp);
        this.tmp = st2.value.equals("true");
        assertTrue("op3 error : st2 = "+st2.value+", insteadOf true",this.tmp);
        this.tmp = st3.value.equals("The concat test is OK !");
        assertTrue("op3 error : st3 = "+st3.value+", insteadOf The concat test is OK !",this.tmp);
        this.tmp = st4.value == true;
        assertTrue("op3 error : st4 = "+st4.value+", insteadOf true",this.tmp);
        this.tmp = st5.value == false;
        assertTrue("op3 error : st5 = "+st5.value+", insteadOf false",this.tmp);
        this.tmp = st6.value == true;
        assertTrue("op3 error : st6 = "+st6.value+", insteadOf true",this.tmp);
        this.tmp = st7.value == false;
        assertTrue("op3 error : st7 = "+st7.value+", insteadOf false",this.tmp);
        this.tmp = st8.value.equals("1999");
        assertTrue("op3 error : st8 = "+st8.value+", insteadOf 1999",this.tmp);
        this.tmp = st9.value.equals("99/04/01");
        assertTrue("op3 error : st9 = "+st9.value+", insteadOf 99/04/01",this.tmp);
        this.tmp = st10.value.equals("234");
        assertTrue("op3 error : st10 = "+st10.value+", insteadOf 234",this.tmp);
        this.tmp = st11.value.equals("12345");
        assertTrue("op3 error : st11 = "+st11.value+", insteadOf 12345",this.tmp);
        this.tmp = st12.value == 7.0;
        assertTrue("op3 error : st12 = "+st12.value+", insteadOf 7.0",this.tmp);
        this.tmp = st13.value.equals("The XML");
        assertTrue("op3 error : st13 = "+st13.value+", insteadOf The XML",this.tmp);
        this.tmp = st14.value.equals("bc:da");
        assertTrue("op3 error : st14 = "+st14.value+", insteadOf bc:da",this.tmp);
    }

    public void testXPath4() throws Exception {
        String st1 = this.fpt.op4("15","PT9S");
        this.tmp = st1.equals("duration1234");
        assertTrue("op4 error : st1 = "+st1+", insteadOf duration1234",this.tmp);
    }

    public void testXPath5() throws Exception {
        Date d = new Date();
        Calendar cal = new GregorianCalendar();
        cal.setTime(d);
        cal.add(Calendar.SECOND,7);
        int year = cal.get(Calendar.YEAR);
        String st1 = this.fpt.op5(cal,year);
        this.tmp = st1.equals("date12") || st1.equals("date21");
        assertTrue("op5 error : st1 = "+st1+", insteadOf date12 or date21",this.tmp);
    }

    public void testXPath6() throws Exception {
        Date d = new Date();
        Calendar cal1 = new GregorianCalendar();
        cal1.setTime(d);
        cal1.add(Calendar.SECOND,4);
        cal1.get(Calendar.DAY_OF_MONTH);
        Calendar cal2 = new GregorianCalendar();
        cal2.add(Calendar.SECOND,10);
        cal2.get(Calendar.DAY_OF_MONTH);

        int year = cal2.get(Calendar.YEAR);
        int month = cal2.get(Calendar.MONTH)+1;
        int day = cal2.get(Calendar.DAY_OF_MONTH);
        int hour = cal2.get(Calendar.HOUR_OF_DAY);
        int minute = cal2.get(Calendar.MINUTE);
        int second = cal2.get(Calendar.SECOND);

        String dt = year+"-"+add0(month)+"-"+add0(day)+"T"+add0(hour)+":"+add0(minute)+":"+add0(second);

        String st1 = this.fpt.op6(cal1,dt);
        this.tmp = st1.equals("dateTime12");
        assertTrue("op6 error : st1 = "+st1+", insteadOf dateTime12",this.tmp);
    }

    private String add0(int i) {
        String res = "";
        if (i<10) {
            res = "0";
        }
        res = res + Integer.toString(i);
        return res;
    }

    public void testXPathQuery1() throws Exception {
        Address address = new Address();
        address.setNumber(new Integer(2));
        address.setStreet("Mayencin");
        address.setPostalCode("38130");
        address.setCity("Echirolles");
        Person person = new Person();
        person.setFirstName("Joe");
        person.setLastName("GOGUIN");
        person.setAddress(address);
        person.setAge(new Integer(31));
        person.setMarried(new Boolean(true));

        String out = this.fpt.op7(person);
        this.tmp = out.equals("Echirolles");
        assertTrue("op7 error : out = "+out+", insteadOf Echirolles",this.tmp);
    }

    public void testXPathQuery2() throws Exception {
        Address address = new Address();
        address.setNumber(new Integer(2));
        address.setStreet("Mayencin");
        address.setPostalCode("38130");
        address.setCity("Echirolles");
        Person person = new Person();
        person.setFirstName("Joe");
        person.setLastName("GOGUIN");
        person.setAddress(address);
        person.setAge(new Integer(31));
        person.setMarried(new Boolean(true));

        String out = this.fpt.op8(person);
        this.tmp = out.equals("Echirolles");
        assertTrue("op8 error : out = "+out+", insteadOf Echirolles",this.tmp);
    }

    public void testXPathQuery3() throws Exception {
        CSType cs = new CSType();
        cs.setNb("1");
        Info info = new Info();
        info.setCs(cs);
        info.setInfo("hello");
        String out = this.fpt.op9("toto",info);
        this.tmp = out.equals("toto");
        assertTrue("op9 error : out = "+out+", insteadOf toto",this.tmp);
    }

    public void testXPathQuery4() throws Exception {
        CSType cs = new CSType();
        cs.setNb("2");
        Info2 info2 = new Info2();
        info2.setCs(cs);
        info2.setInfo("hello");
        String out = this.fpt.op10("toto",info2);
        this.tmp = out.equals("toto");
        assertTrue("op10 error : out = "+out+", insteadOf toto",this.tmp);
    }

    public void testXPathQuery5() throws Exception {
        CSType2 cs2 = new CSType2();
        cs2.setNb("3");
        Info3 info3 = new Info3();
        info3.setCs(cs2);
        info3.setInfo("hello");
        String out = this.fpt.op11("toto",info3);
        this.tmp = out.equals("toto");
        assertTrue("op11 error : out = "+out+", insteadOf toto",this.tmp);
    }

    public void testXPathQuery6() throws Exception {
        CSType2 cs2 = new CSType2();
        cs2.setNb("4");
        Info4 info4 = new Info4();
        info4.setCs(cs2);
        info4.setInfo("hello");
        String out = this.fpt.op12("toto",info4);
        this.tmp = out.equals("toto");
        assertTrue("op12 error : out = "+out+", insteadOf toto",this.tmp);
    }

    public void testXPathQuery7() throws Exception {
        Address address = new Address();
        address.setNumber(new Integer(2));
        address.setStreet("Mayencin");
        address.setPostalCode("38130");
        address.setCity("Echirolles");
        Person person = new Person();
        person.setFirstName("Joe");
        person.setLastName("GOGUIN");
        person.setAddress(address);
        person.setAge(new Integer(31));
        person.setMarried(new Boolean(true));

        String out = this.fpt.op13(person);
        this.tmp = out.equals("Echirolles");
        assertTrue("op13 error : out = "+out+", insteadOf Echirolles",this.tmp);
    }

    public void testXPathQuery8() throws Exception {
        Address address = new Address();
        address.setNumber(new Integer(2));
        address.setStreet("Mayencin");
        address.setPostalCode("38130");
        address.setCity("Echirolles");
        Person person = new Person();
        person.setFirstName("Joe");
        person.setLastName("GOGUIN");
        person.setAddress(address);
        person.setAge(new Integer(31));
        person.setMarried(new Boolean(true));

        Person out = this.fpt.op14(person);
        this.tmp = out.getAddress().getCity().equals("Echirolles");
        assertTrue("op13 error : out = "+out+", insteadOf Echirolles",this.tmp);
    }

    public void testXPathQuery9() throws Exception {
        Address address = new Address();
        address.setNumber(new Integer(2));
        address.setStreet("Mayencin");
        address.setPostalCode("38130");
        address.setCity("Echirolles");
        Person person = new Person();
        person.setFirstName("Joe");
        person.setLastName("GOGUIN");
        person.setAddress(address);
        person.setAge(new Integer(31));
        person.setMarried(new Boolean(true));

        Person out = this.fpt.op15(person);
        this.tmp = out.getAddress().getCity().equals("Echirolles");
        assertTrue("op13 error : out = "+out+", insteadOf Echirolles",this.tmp);
    }

}
